#!R
# Creating summary table 3
# 	Assumes FurfData.filenames and TypeIresults.list in the order as commented below
#	Requires Results/BaselineTypeI_1.RData etc. to exist
#		

#FurfData.filenames <- c('BaselineOriginalFurfineOutputDummyData.RData', 'EndOfDayFurfineOutputDummyData.RData', 'RoundIntFurfineOutputDummyData.RData', 'ExactIntFurfineOutputDummyData.RData', 'kNNrefinedFurfineOutputDummyData.RData')
# num_results_files <- 15

source('typeIerrorfunctions_pfdrincluded.R')

#TypeIresult.list <- c('BaselineTypeI', 'EndOfDayTypeI', 'RoundIntTypeI', 'ExactIntTypeI',  'RempelTypeI')
TypeIresult.list <- paste('Results/', TypeIresult.list, sep='')

pfdrQrow <- matrix(NA_real_, length(TypeIresult.list), 5)
pfdrB <- matrix(NA_real_, length(TypeIresult.list),1)
for(file.n in TypeIresult.list){
	if(num_results_files ==1){
		load(paste(file.n, '_1', '.RData', sep='')) -> pfdrT1.s
		eval(parse(text=paste('pfdrQrow[', which(file.n==TypeIresult.list),',] <-  QuantilesTableG(', pfdrT1.s, '$tau)', sep='')))
		eval(parse(text=paste('pfdrB[', which(file.n==TypeIresult.list),',1] <-  length(', pfdrT1.s, '$tau)', sep='')))
	} else {
		
		FULL <- vector('list', num_results_files*2)
		setwd('Results')
		for(i in 1:num_results_files){
			load(paste(full_str,'_',  i, '.RData', sep='')) -> results

			eval(parse(text=paste('FULL[[', i, ']] <- ', results, sep='')))

		}
		if(file.exists(paste(full_str, 'B_', i, '.RData', sep=''))){
			# if the files were too big so that Results files had to be split into A/B 
			for(i in 1:num_results_files){
				load(paste(full_str,'B_', i, '.RData', sep='')) -> results
				eval(parse(text=paste('FULL[[', i + num_results_files, ']] <- ', results, sep='')))
			}
		}
		Full_pfdr <-do.call(c, lapply(FULL, function(x) x$tau))
		pfdrQrow[which(file.n==TypeIresult.list),] <- QuantilesTableG(Full_pfdr)
		pfdrB[which(file.n==TypeIresult.list),1] <- length(Full_pfdr)
	}
}


FurfData.filenames <- paste('FurfineOutput/', FurfData.filenames, sep='')

nrows <- matrix(NA_real_, 1, length(FurfData.filenames))
for(FurfData.filename in FurfData.filenames){
	load(FurfData.filename)
	nrows[which(FurfData.filename==FurfData.filenames)] <- nrow(furfdat)
}

Baseline.nrows <- nrows[1]
percent_obs_restricted <- nrows/Baseline.nrows*100

Table3 <- pfdrQrow
Table3 <- Table3*100
Table3 <- cbind(Table3, pfdrB)
Table3 <- cbind(Table3, t(percent_obs_restricted))
Table3 <- Table3[c(5, 1,2,4,3),]
row.names(Table3) <- c('kNN', 'Baseline', 'End Of Day', 'Exact Int', 'Round Int')
colnames(Table3) <- c('Mean(FDR)', 'x=0.2', 'x=0.1', 'x=0.05', 'x=0.01', 'B', '% Full Sample')
xtable(Table3)

