%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Supporting function for matlab to receive data piped from R 
%	(essentially reading a csv)
%	
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function data = R_recv_matrix(filename)

fid = fopen(filename);
if(fid == -1)
    warning('Cannot open file "%s" for reading', filename)
    data = [];
    return
end

try
    % read in the lines
    A = textscan(fid, '%s', 'Delimiter', '\n');
    fclose(fid);
catch me
    fclose(fid);
    retrow(me)
end

A = A{1};
nrow = length(A);
B = textscan(A{1}, '%f', 'Delimiter', ',');
if size(B{1},1)==0
	%then there are column names here
	B = textscan(A{2}, '%f', 'Delimiter', ',');
end
B = B{1};
ncol = length(B);
data = zeros(nrow, ncol);
data(1,:) = B;
for c=2:nrow
    B = textscan(A{c}, '%f', 'Delimiter', ',');
    if size(B{1},1) > 0
        data(c,:) = B{1};
    end
end

