%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This script takes a payments matrix  and generates a training model
% therefrom. (modelI = Output)
%
% To be called from BootstrapModelTrainingScript.R
% 	Assumes FurfineData = uniquely identified loans, lvts is payments data
% Rempel 2013

disp('Initiating Model Training Algorithm')
%tic; 

format long g

% symmetric bounds
bpsl = 0.5;                % ON rate band (around the target) to consider
bpsh = 0.5;                % Set to .5 to match Hendry, Armantier/Copeland


% specifying column locations for variables of interest

BoCid = 2;

timecol = 2;
senderValue_column = 3;
returnValue_column = 13;
sender_column = 4;
ond = 365;
receiver_column = 5;
intrate_column = 21;
ONrate_column = 7;

senderTransactionIdColumn = 10;
SenderDuplicateIndicatorValue = 4;
SenderSelectedDuplicateValue = 2;

receiverTransactionIdColumn = 20;
ReceiverDuplicateIndicatorValue = 6;
ReceiverSelectedDuplicateValue = 3;

% original payments data mat file (in hdf5 format)

%lvtsdatafile = '/scratch/remm/LVTS/FurfinePaperWork/Inputs/LVTS_2005-2011ordered.mat'; % this is the original payments data mat file, ordered by date/time
%lvtsdatafile = '../LVTS_hdf5format.mat'; % this is the original payments
%data mat file ordered by transaction number
samplesize = 50; % This is the samplesize parameter for the rempel criterion synthetic training algorithm

TrainedDataI = Training_Data(FurfineData, lvts, ControlSyntheticForParticipants, min_loansize, min_sentime);
sprintf('TrainData Size %d', size(TrainedDataI,1))
TrainedXs = GeneratingKNNcovariates(TrainedDataI);
TrainedYs = TrainedDataI(:,22);
TrainedYs(TrainedYs > 0) = 1;
%sprintf('TrainedYs %d', length(find(TrainedYs ==0)))
if choiceK > 0
    modelI = RempelKNNtraining(TrainedXs, TrainedDataI(:,22), choiceK);
else
    modelI = RempelKNNtraining(TrainedXs, TrainedDataI(:,22));
end
%save(['TrainedLVTS_' num2str(b) '_' methodDup2 'Sample_' num2str(subsample_number)  '.mat'], 'modelI', '-v7.3')

disp('done model script')
