#! R


source('typeIerrorfunctions_pfdrincluded.R') 

load('Results/RempelTypeI_1.RData') 

Rempel_pfdrQtable  <- QuantilesTableG(RempelTypeI$tau)

write.table(t(Rempel_pfdrQtable), file='kNNrefinedDummyDataPFDRtable.csv', sep=',')


# Generating the equivalent of Fig 1 with the simulated (dummy) data:
kNN_pfdr <- RempelTypeI$tau
kNN_pfdr_density <- density(RempelTypeI$tau)
max.y <- 50
ylims <- c(0,max.y)
max.x <- 0.8
pdf('SimulatedDummyData_kNNFurfinePFDR_Distribution.pdf')
plot(kNN_pfdr_density, main='', xlim=c(0,max.x),ylim=ylims,  xlab=expression(paste('False Discovery Rates ( ', hat(FDR), ' )', sep='')), col='brown', lwd=2, axes=F)
axis(1, labels=paste(seq(0, max.x, 0.05)*100, '%', sep=''), at=seq(0, max.x, 0.05))
axis(2)
x <- kNN_pfdr_density[[1]]
y <- kNN_pfdr_density[[2]]

x.q90 <- quantile(kNN_pfdr, 0.90)
x.q95 <- quantile(kNN_pfdr, 0.95)
x.q99 <- quantile(kNN_pfdr, 0.99)
xx <- x[which(x <= x.q90)]
yy <- y[which(x <= x.q90)]
polygon(c(xx, rev(xx)), c(rep(0, length(xx)), rev(yy)), col='blue', border='blue')
x90.95 <- which(x > x.q90 & x <= x.q95)
xx95 <- x[x90.95]
yy95 <- y[x90.95]
polygon(c(xx95, rev(xx95)), c(rep(0, length(xx95)), rev(yy95)), col='orange', border='orange')
x95.99 <- which(x > x.q95 & x <= x.q99)
xx99 <- x[x95.99]
yy99 <- y[x95.99]
polygon(c(xx99, rev(xx99)), c(rep(0, length(xx99)), rev(yy99)), col='red', border='red')

# legend:
legend('topright', legend=c('0  -  90% CI', '90 - 95% CI', '95 - 99% CI'), col=c('blue', 'orange', 'red'), fill=c('blue', 'orange', 'red'))
dev.off()


