## Aggregating the results from different samples of the same test and across tests

# Tests Table 1:
	# Full Sample, restricted payments
	# SubSamples - restricted payments

# Tests Table 2:
	# refinements - restricted payments


# Tests Table 3:
	# Full Sample Permutation
	# SubSamples Permutation

# Tests Table 4:
	# Refinements - permutation


# Plot 1: adjusted pFDR - restricted payments, fullxsubsamples

# Plot 2: adjusted pFDR - restricted payments, full x refinements

# Plot 3: standard pFDR - permutation, full x subsamples

# Plot 4: standard pFDR - permutation, full x refinements

##########################

source('typeIerrorfunctions_pfdrincluded.R')
#
# Table 1:

full_str <- 'BaselineTypeI'
preQ12005_str <- 'PreCrisisQ12005TypeI_'
preQ22006_str <- 'PreCrisisQ22006TypeI_'

crisis_str <- 'CrisisTypeI'
elb_str <- 'ELBTypeI'
pelb_str <- 'PELBTypeI'

FurfData.filename <- 'FurfineOutput/BaselineOriginalFurfineOutput.RData'


# aggregate all of the full sample results
num_samples <- 15
FULL <- vector('list', num_samples*2)
setwd('Results')
for(i in 1:num_samples){
	load(paste(full_str,'_',  i, '.RData', sep='')) -> results

	eval(parse(text=paste('FULL[[', i, ']] <- ', results, sep='')))

}

for(i in 1:num_samples){
        load(paste(full_str,'B_', i, '.RData', sep='')) -> results
        eval(parse(text=paste('FULL[[', i + num_samples, ']] <- ', results, sep='')))
}

Full_pfdr <-do.call(c, lapply(FULL, function(x) x$tau))
Full_pfdrQtable <- QuantilesTableG(Full_pfdr)

# loading each of the subsamples (note, currently do not have multiple samples for the subsamples, treat similarly to Full sample if we do)
PREQ12005 <- vector('list', num_samples)

for(i in 1:num_samples){
        load(paste(preQ12005_str, i, '.RData', sep='')) -> results
	 eval(parse(text=paste('PREQ12005[[', i,']] <- ', results, sep=''))) 

}

PreQ12005_pfdr  <-do.call(c, lapply(PREQ12005, function(x) x$tau))
PreQ12005_pfdrQtable <- QuantilesTableG(PreQ12005_pfdr)

PREQ22006 <- vector('list', num_samples)

for(i in 1:num_samples){
        load(paste(preQ22006_str, i, '.RData', sep='')) -> results
         eval(parse(text=paste('PREQ22006[[', i,']] <- ', results, sep='')))

}

PreQ22006_pfdr  <-do.call(c, lapply(PREQ22006, function(x) x$tau))
PreQ22006_pfdrQtable <- QuantilesTableG(PreQ22006_pfdr)



PRE <- vector('list', num_samples*2)

for(i in 1:num_samples){
        load(paste(crisis_str,'_', i, '.RData', sep='')) -> results
         eval(parse(text=paste('PRE[[', i,']] <- ', results, sep='')))

}

for(i in 1:(num_samples)){
        load(paste(crisis_str, 'B_',  i, '.RData', sep='')) -> results
        eval(parse(text=paste('PRE[[', i + num_samples, ']] <- ', results, sep='')))
}




Crisis_pfdr  <-do.call(c, lapply(PRE, function(x) x$tau))
Crisis_pfdrQtable <- QuantilesTableG(Crisis_pfdr)

PRE <- vector('list', num_samples*2)

for(i in 1:num_samples){
        load(paste(elb_str,'_', i, '.RData', sep=''))
         eval(parse(text=paste('PRE[[', i,']] <- ', results, sep='')))

}

for(i in 1:num_samples){
        load(paste(elb_str,'B_', i, '.RData', sep='')) -> results
        eval(parse(text=paste('PRE[[', i + num_samples, ']] <- ', results, sep='')))
}



ELB_pfdr  <-do.call(c, lapply(PRE, function(x) x$tau))
ELB_pfdrQtable <- QuantilesTableG(ELB_pfdr)

PRE <- vector('list', num_samples*2)

for(i in 1:num_samples){
        load(paste(pelb_str,'_', i, '.RData', sep='')) -> results
        eval(parse(text=paste('PRE[[', i, ']] <- ', results, sep='')))
}

for(i in 1:num_samples){
        load(paste(pelb_str, 'B_',i, '.RData', sep='')) -> results
        eval(parse(text=paste('PRE[[', i + num_samples, ']] <- ', results, sep='')))
}


PELB_pfdr  <-do.call(c, lapply(PRE, function(x) x$tau))
PELB_pfdrQtable <- QuantilesTableG(PELB_pfdr)



setwd('..') # stepping out of Results

# adding number of observations in original data / subsamples
load(FurfData.filename)
colnames(furfdat) <- c('date', 'time', 'value', 'sender', 'receiver', 'tranche', 'ONrate', 'jumbo', 'misc', 'transnum', 'date_r', 'time_r', 'value_r', 'sender_r', 'receiver_r', 'tranche_r', 'ONrate_r', 'jumbo_r', 'misc_r', 'transnum_r', 'furf_rate', 'mltpl')

 BNP <-  20070809
 ELB_s <- 20090421
 ELB_e <- 20100601

strt <- as.Date('20050101', '%Y%m%d')
names(furfdat)

furfdat <- as.data.frame(furfdat)

preQ12005crisis <- furfdat[which(furfdat$date <= 20060331),]
preQ22006crisis <- furfdat[which(furfdat$date > 20060331 & furfdat$date < BNP),]
crisis <- furfdat[which(furfdat$date < ELB_s & furfdat$date >=BNP),]
elb <- furfdat[which(furfdat$date >= ELB_s & furfdat$date <=ELB_e),]
pelb <- furfdat[which(furfdat$date > ELB_e),]

Hendry.nrows <- nrow(furfdat)
precrisisQ12005.nrows <- nrow(preQ12005crisis)
precrisisQ22006.nrows <- nrow(preQ22006crisis)
crisis.nrows <- nrow(crisis)
elb.nrows <- nrow(elb)
pelb.nrows <- nrow(pelb)

num_obs_subsamples <- c(Hendry.nrows, precrisisQ12005.nrows, precrisisQ22006.nrows, crisis.nrows, elb.nrows, pelb.nrows)
percent_obs <- num_obs_subsamples/Hendry.nrows

# Table 1


Table1 <- rbind(Full_pfdrQtable,PreQ12005_pfdrQtable ,PreQ22006_pfdrQtable, Crisis_pfdrQtable, ELB_pfdrQtable, PELB_pfdrQtable)
Table1 <- cbind(Table1, c(length(Full_pfdr), length(PreQ12005_pfdr), length(PreQ22006_pfdr), length(Crisis_pfdr),length(ELB_pfdr),length(PELB_pfdr)))
Table1 <- cbind(Table1, percent_obs)
Table1 <- Table1*100
Table1[,6] <- Table1[,6]/100
colnames(Table1)[6] <- 'B'
library(xtable)
xtable(Table1)

# Plot 1:
Full_pfdr_density <- density(Full_pfdr)
max.y <- 40
ylims <- c(0,max.y)
max.x <- 0.4
pdf('FullSampleTypeIerrorDistribution_fdr_2015.pdf')
plot(Full_pfdr_density, main='', xlim=c(0,max.x),ylim=ylims,  xlab=expression(paste('False Discovery Rates ( ', hat(FDR), ' )', sep='')), col='brown', lwd=2, axes=F)
axis(1, labels=paste(seq(0, max.x, 0.05)*100, '%', sep=''), at=seq(0, max.x, 0.05))
axis(2)
x <- Full_pfdr_density[[1]]
y <- Full_pfdr_density[[2]]

x.q90 <- quantile(Full_pfdr, 0.90)
x.q95 <- quantile(Full_pfdr, 0.95)
x.q99 <- quantile(Full_pfdr, 0.99)
xx <- x[which(x <= x.q90)]
yy <- y[which(x <= x.q90)]
polygon(c(xx, rev(xx)), c(rep(0, length(xx)), rev(yy)), col='blue', border='blue')
x90.95 <- which(x > x.q90 & x <= x.q95)
xx95 <- x[x90.95]
yy95 <- y[x90.95]
polygon(c(xx95, rev(xx95)), c(rep(0, length(xx95)), rev(yy95)), col='orange', border='orange')
x95.99 <- which(x > x.q95 & x <= x.q99)
xx99 <- x[x95.99]
yy99 <- y[x95.99]
polygon(c(xx99, rev(xx99)), c(rep(0, length(xx99)), rev(yy99)), col='red', border='red')

# legend:
legend('topright', legend=c('0  -  90% CI', '90 - 95% CI', '95 - 99% CI'), col=c('blue', 'orange', 'red'), fill=c('blue', 'orange', 'red'))
dev.off()



Full.den <- density(Full_pfdr)
PreQ1.den <- density(PreQ12005_pfdr)
PreQ2.den <- density(PreQ22006_pfdr)
Crisis.den <- density(Crisis_pfdr)
ELB.den <- density(ELB_pfdr)
PELB.den <- density(PELB_pfdr)


#ylims <- c(0,80)

#pdf('SubSamplesRpfdr_uAxis.pdf')
colours <- c('black', 'cyan', 'skyblue', 'darkorange', 'purple', 'brown')
plot(NULL, col=colours[1], ylab='Density', xlab=expression(paste('Postive False Discovery Rates (', tilde(tau), ')', sep='')), lwd=2, ylim= ylims, xlim=c(0, max.x))
lines(PreQ1.den, col=colours[2], lwd=1.5)
lines(PreQ2.den, col=colours[3], lwd=1.5)
lines(Crisis.den, col=colours[4], lwd=1.5)
lines(ELB.den, col=colours[5], lwd=1.5)
lines(PELB.den, col=colours[6], lwd=1.5)
lines(Full.den, col=colours[1], lwd=2)
legend('topright', legend=c('2005-2011', 'Q1 2005-Q1 2006', 'Q2 2006 - BNP Paribas', 'BNP Paribas - Apr. 2009', 'ELB', 'June 2010 - Dec 2011'), col=colours, fill=colours)
#dev.off()




## Table 2: Duplicates
furfdat.split <- split(furfdat, as.factor(furfdat[,1]))
furfdups <- DuplicatePercentagesTable(furfdat.split)
#
results <- vector('list', length(FULL))
for(i in 1:length(FULL)){
	results[[i]] <- FULL[[i]]$raw
}
results <- do.call(c, results)
Full_dups <- DuplicatePercentagesTable(results)
DupTable <- cbind(furfdups, Full_dups)
xtable(t(DupTable)*100)




# Refinements

remp_str <- 'RempelTypeI'
round_str <- 'roundedBPTypeI'
roundExact_str <- 'roundedExactTypeI'
post4pm_str <- 'post4pmTypeI'


setwd('Results')
# loading each of the subsamples (note, currently do not have multiple samples for the subsamples, treat similarly to Full sample if we do)
num_samples <- 15
PRE <- vector('list', num_samples*2)

for(i in 1:num_samples){
     load(paste(remp_str,'_', i, '.RData', sep='')) -> results
         eval(parse(text=paste('PRE[[', i,']] <- ', results, sep='')))

}
for(i in 1:num_samples){
     load(paste(remp_str,'B_', i, '.RData', sep='')) -> results
         eval(parse(text=paste('PRE[[', i + num_samples,']] <- ', results, sep='')))

}

Rempel_pfdr  <-do.call(c, lapply(PRE, function(x) x$tau))
Rempel_pfdrQtable <- QuantilesTableG(Rempel_pfdr)


num_samples <- 15
PRE <- vector('list', num_samples*2)


for(i in 1:num_samples){
        load(paste(round_str,'_', i, '.RData', sep='')) -> results
         eval(parse(text=paste('PRE[[', i,']] <- ', results, sep='')))
}

for(i in 1:num_samples){
        load(paste(round_str,'B_', i, '.RData', sep='')) -> results
         eval(parse(text=paste('PRE[[',num_samples +  i,']] <- ', results, sep='')))
}


Round_pfdr  <-do.call(c, lapply(PRE, function(x) x$tau))
Round_pfdr[which(!is.finite(Round_pfdr))] <- 0
Round_pfdrQtable <- QuantilesTableG(Round_pfdr)


num_samples <- 15
PRE <- vector('list', num_samples*2)


for(i in 1:num_samples){
        load(paste(roundExact_str,'_', i, '.RData', sep='')) -> results
         eval(parse(text=paste('PRE[[', i,']] <- ', results, sep='')))
}

for(i in 1:num_samples){
        load(paste(roundExact_str,'B_', i, '.RData', sep='')) -> results
         eval(parse(text=paste('PRE[[',num_samples +  i,']] <- ', results, sep='')))
}


RoundExact_pfdr  <-do.call(c, lapply(PRE, function(x) x$tau))
RoundExact_pfdr[which(!is.finite(RoundExact_pfdr))] <- 0
RoundExact_pfdrQtable <- QuantilesTableG(RoundExact_pfdr)





num_samples <- 15
PRE <- vector('list', num_samples*2)

for(i in 1:num_samples){
        load(paste(post4pm_str,'_', i, '.RData', sep='')) -> results
         eval(parse(text=paste('PRE[[', i,']] <- ', results, sep='')))
}

for(i in 1:num_samples){
        load(paste(post4pm_str,'B_', i, '.RData', sep='')) -> results
         eval(parse(text=paste('PRE[[',num_samples +  i,']] <- ', results, sep='')))
}


post4pm_pfdr  <-do.call(c, lapply(PRE, function(x) x$tau))
post4pm_pfdrQtable <- QuantilesTableG(post4pm_pfdr)
setwd('..')
FurfData.filename <- 'FurfineOutput/BaselineOriginalFurfineOutput.RData'
load(FurfData.filename)
Baseline.nrows <- nrow(furfdat)
FurfData.filename <- 'FurfineOutput/kNNrefinedFurfineOutput.RData'
load(FurfData.filename)
Rempel.nrows <- nrow(furfdat)
FurfData.filename <- 'FurfineOutput/RoundedBPFurfineOutput.RData'
load(FurfData.filename)
RoundedBP.nrows <- nrow(furfdat)
FurfData.filename <- 'FurfineOutput/RoundedBPexactFurfineOutput.RData'
load(FurfData.filename)
RoundedBPexact.nrows <- nrow(furfdat)
FurfData.filename <- "FurfineOutput/EndOfDayFurfineOutput.RData"
load(FurfData.filename)
Post4pm.nrows <- nrow(furfdat)

numobs_restrictions <- c(Baseline.nrows, Post4pm.nrows, RoundedBP.nrows, RoundedBPexact.nrows, Rempel.nrows)
percent_obs_restricted <- numobs_restrictions/Baseline.nrows*100


Table3 <- rbind(Full_pfdrQtable, post4pm_pfdrQtable, Round_pfdrQtable, RoundExact_pfdrQtable, Rempel_pfdrQtable)
Table3 <- Table3*100
Table3 <- cbind(Table3, c(length(Full_pfdr), length(post4pm_pfdr),length(Round_pfdr),length(RoundExact_pfdr), length(Rempel_pfdr)))
Table3 <- cbind(Table3, percent_obs_restricted)
colnames(Table3)[6] <- 'B'
Table3 <- Table3[c(5, 1,2,4,3),]
xtable(Table3)

# plot comparision of refinements


# adjust the post4pm so that the bias correction isn't extreme 
	# use the post4pm lvts against post4pm?



bwv <- 0.00045
Full.den <- density(Full_pfdr, bw=bwv)
post4pm.den <- density(post4pm_pfdr, bw=bwv)
Round.den <- density(Round_pfdr[which(Round_pfdr < 1)])
RoundExact.den <- density(RoundExact_pfdr, bw=bwv)
Rempel.den <- density(Rempel_pfdr, bw=bwv)
ylims=c(0,75)

#pdf('RefinementsRpfdr_uAxis.pdf')
colours <- c('black', 'cyan', 'darkorange', 'red', 'purple', 'brown')
plot(NULL, col=colours[1],ylab='Density', xlab=expression(paste('Postive False Discovery Rates (', tilde(tau), ')', sep='')), ylim=ylims,  main='', lwd=2, xlim=c(0,0.9))
lines(post4pm.den, col=colours[2], lwd=1.5) 
lines(Round.den, col=colours[3], lwd=1.5)
lines(RoundExact.den, col=colours[4], lwd=1.5)
lines(Rempel.den, col=colours[5], lwd=1.5)
lines(Full.den, col=colours[1], lwd=2)
legend('topright', legend=c('Original Furfine', 'Post-4pm', 'Rounded Interest', 'Exact Rounded Interest', 'kNN Duplicate'), col=colours, fill=colours)

#dev.off()



# Supplemental BS aggregation

full_str1 <- 'supp_100BS_BaselineTypeI'
full_str2 <- 'supp_200BS_BaselineTypeI'
full_str5 <- 'supp_500BS_BaselineTypeI'
full_str10 <- 'supp_1000BS_BaselineTypeI'


FurfData.filename <- 'FurfineOutput/BaselineOriginalFurfineOutput.RData'


# aggregate all of the full sample results
num_samples <- 1
FULL1 <- vector('list', num_samples*2)
setwd('Results')
for(i in 1:num_samples){
        load(paste(full_str1,'_',  i, '.RData', sep='')) -> results

        eval(parse(text=paste('FULL1[[', i, ']] <- ', results, sep='')))

}

for(i in 1:num_samples){
        load(paste(full_str1,'B_', i, '.RData', sep='')) -> results
        eval(parse(text=paste('FULL1[[', i + num_samples, ']] <- ', results, sep='')))
}

Full_pfdr1 <-do.call(c, lapply(FULL1, function(x) x$tau))
Full_pfdrQtable1 <- QuantilesTableG(Full_pfdr1)


num_samples <- 2
FULL2 <- vector('list', num_samples*2)
for(i in 1:num_samples){
        load(paste(full_str2,'_',  i, '.RData', sep='')) -> results

        eval(parse(text=paste('FULL2[[', i, ']] <- ', results, sep='')))

}

for(i in 1:num_samples){
        load(paste(full_str2,'B_', i, '.RData', sep='')) -> results
        eval(parse(text=paste('FULL2[[', i + num_samples, ']] <- ', results, sep='')))
}

Full_pfdr2 <-do.call(c, lapply(FULL2, function(x) x$tau))
Full_pfdrQtable2 <- QuantilesTableG(Full_pfdr2)


num_samples <- 5
FULL5 <- vector('list', num_samples*2)
for(i in 1:num_samples){
        load(paste(full_str5,'_',  i, '.RData', sep='')) -> results

        eval(parse(text=paste('FULL5[[', i, ']] <- ', results, sep='')))

}

for(i in 1:num_samples){
        load(paste(full_str5,'B_', i, '.RData', sep='')) -> results
        eval(parse(text=paste('FULL5[[', i + num_samples, ']] <- ', results, sep='')))
}

Full_pfdr5 <-do.call(c, lapply(FULL5, function(x) x$tau))
Full_pfdrQtable5 <- QuantilesTableG(Full_pfdr5)


num_samples <- 10
FULL10 <- vector('list', num_samples*2)
for(i in 1:num_samples){
        load(paste(full_str,'_',  i, '.RData', sep='')) -> results

        eval(parse(text=paste('FULL10[[', i, ']] <- ', results, sep='')))

}

for(i in 1:num_samples){
        load(paste(full_str,'B_', i, '.RData', sep='')) -> results
        eval(parse(text=paste('FULL10[[', i + num_samples, ']] <- ', results, sep='')))
}

Full_pfdr10 <-do.call(c, lapply(FULL10, function(x) x$tau))
Full_pfdrQtable10 <- QuantilesTableG(Full_pfdr10)


TableSup <- rbind(Full_pfdrQtable1, Full_pfdrQtable2, Full_pfdrQtable5, Full_pfdrQtable10, Full_pfdrQtable)
TableSup <- TableSup*100
TableSup <- cbind(TableSup, c(length(Full_pfdr1), length(Full_pfdr2),length(Full_pfdr5),length(Full_pfdr10), length(Full_pfdr)))
colnames(TableSup)[6] <- 'B'
xtable(TableSup)


# BR sensitivity table

load(FurfData.filename) # yields furfdat object
colnames(furfdat) <- c('date', 'time', 'value', 'sender', 'receiver', 'tranche', 'ONrate', 'jumbo', 'misc', 'transnum', 'date_r', 'time_r', 'value_r', 'sender_r', 'receiver_r', 'tranche_r', 'ONrate_r', 'jumbo_r', 'misc_r', 'transnum_r', 'furf_rate', 'mltpl')
furfdat <- as.data.frame(furfdat)


boot_str <- 'BootData/LVTSbootsamplesJ_NumLendDays_1NumReturnDays_20_Numboots_100'
num_samples <- 15
Boot.FULL <- vector('list', num_samples*2)
for(i in 1:num_samples){
        load(paste(boot_str,'_',  i, 'A.RData', sep='')) -> results
        SRdates.l <- lapply(BootSample, function(z) z$SRdates)
        Boot.FULL[[i]] <- SRdates.l
}

for(i in 1:num_samples){
        load(paste(boot_str,'_', i, 'B.RData', sep='')) -> results
        SRdates.l <- lapply(BootSample, function(z) z$SRdates)
        Boot.FULL[[i + num_samples]] <- SRdates.l
}

pfdrSubB_R <- lapply(1:length(FULL), function(z) SummaryPFDR_withDays(FULL[[z]]$raw, furfdat, Boot.FULL[[z]]))

pfdr_within7 <- do.call(c, lapply(pfdrSubB_R, function(z) z$pfdr_5))
pfdr_within14 <- do.call(c, lapply(pfdrSubB_R, function(z) z$pfdr_10))
pfdr_within30 <- do.call(c, lapply(pfdrSubB_R, function(z) z$pfdr_20))
pfdr_withing30 <- do.call(c, lapply(pfdrSubB_R, function(z) z$pfdr_g20))


pfdrSub_Table <- rbind(QuantilesTableG(pfdr_within7), QuantilesTableG(pfdr_within14), QuantilesTableG(pfdr_within30), QuantilesTableG(pfdr_withing30))
rownames(pfdrSub_Table) <- c('Within a week', 'Between 1 and 2 weeks', 'Between 2 weeks and a month', 'Greater than a month')

pfdrSub_Table <- cbind(pfdrSub_Table, c(length(which(!is.na(pfdr_within7))), length(which(!is.na(pfdr_within14))),length(which(!is.na(pfdr_within30))),length(which(!is.na(pfdr_withing30))))/length(pfdr_within7)

pfdrSub_Table <- 100* pfdrSub_Table

colnames(pfdrSub_Table)[6] <- '% samples in range'             

require(xtable)
xtable(pfdrSub_Table)




