#!R

# Supporting functions for RempelBootstrapTest.R
	# RempelTest is for local/serial implementation
	# slavefunction is serial_testfun adapted for parallel (Rmpi) implementation

RempelTest <- function(task){
	# perform task and create results
		pt.start <- proc.time()
		b <- task$bootNumber
		print(sprintf("sample number %d received", b))
		my.sample <- task$bootsample
		class(my.sample)
		dim(my.sample)
		setVariable(matlab, b=b)
		evaluate(matlab, "fprintf('b is %d', b)\n")
		setVariable(matlab, lvts=as.matrix(my.sample))
		evaluate(matlab, "size(lvts)")
		print('Sending sample')
#                       evaluate(matlab, "fprintf('refinement is %s\n', refinement)\n")

	       if(methodTreatDuplicates=='Rempel'){
			print('kNN duplicate method used')
			if(methodDup2=='Hendry'){
				print('loading training data in matlab')

				CMDstringR <- paste('TrainingData/', training_prefix_str, b, training_suffix_str, sep='')
				setVariable(matlab, CMDstring = CMDstringR)
				evaluate(matlab, "load(CMDstring)")
				print('command to matlab to load has been given, waiting for task completion..')
				evaluate(matlab, 'class(modelI)')
				print('model data loaded')
			} else {
			}
		}
	#	getVariable(matlab, 'refinement')$refinement -> refinement.m
	#	print(paste('refinement in matlab is', refinement.m))
		evaluate(matlab, FurfineScript)

		# applying Furfine Algorithm to the lvts data
		 # putting in the full non-parallel script.
		#Fresults <- getVariable(matlab, 'Loans')$Loans
		Fresults <- getVariable(matlab, 'Loans')$Loans
		print('Getting Loans data from Matlab into R')
		print(class(Fresults))
		print(head(Fresults))
		evaluate(matlab, "disp('Waiting for R instruction')")
		comp.time <- proc.time() - pt.start
		if(nrow(Fresults)<1){
			# no loans identified!
			print('No loans identified in this sample')

			results <- list(bootNumber=b, num_loans=0, matches = NULL, comp.time=comp.time, num_nonunqiue = NULL, num_obs=nrow(my.sample))

		} else {
			print('Loans identified in this sample')

			num_nonunique = length(Fresults[,22]>0)
			numloans = nrow(Fresults)
                                results <- list(bootNumber=b, num_loans=numloans, matches=Fresults, comp.time = comp.time, num_nonunique = num_nonunique, num_obs=nrow(my.sample))
                }


		 # Rslave receiving data from the pipe
		if(nrow(Fresults)>1) print(sprintf("Results from matlab %d", Fresults[1,1]))
		# clearing un-needed data
		rm(my.sample)
		print('Sending Results')
		return(results)
}



slavefunction <- function(){
	# remote indicates the connection to use to pass Matlab data to R (R.matlab, getVariable(,,remote=?) )
        junk <- 0
        done <- 0
        iter.counter = 0
        # on default communicator = 1
        # communicator = 1
        print("In Slave Function")
        flush.console()
        while(done !=1){
                starttime = proc.time()[3]
                iter.count = iter.counter + 1
                master.node <- 0
                print(sprintf("sending tag %d", slave.tag.ready))
                mpi.send.Robj(obj=junk,dest=master.node, tag=slave.tag.ready) # , comm=communicator)
                task <- mpi.recv.Robj(source=mpi.any.source(), tag=mpi.any.tag()) # , comm=communicator)
                task.info <- mpi.get.sourcetag()
                tag <- task.info[2]
               print(sprintf("received tag %d", tag))
                if(tag==master.tag.work){
                        # perform task and create results
			results <- RempelTest(task)
                         # Rslave receiving data from the pipe
                        mpi.send.Robj(obj=results, dest=master.node, tag=slave.tag.finished)
                } else if (tag==master.tag.done){
                        # Master has no more tasks. Exit
                        done <- 1
                        print("Master has said there are no more jobs, exiting")
                } else {
                        # unaccounted for messages..
                }
                flush.console()
                if(proc.time()[3] > starttime*500){
                        print(paste("Run-time Hangup on", mpi.comm.rank()))
                        #mpi.send.Robj(junk,master.node, tag=3)
                        break
                }

        }
        # Tell Master that this slave is quiting. 
        mpi.send.Robj(junk, master.node, tag=slave.tag.quit)
}
